<?php
/*
 * Plugin Name: TFS LOLcat
 * Version: 1.1
 * Plugin URI: http://ben-kt.momillett.org/tfslolcat/
 * Description: Based on Dougal Campbell's Pirate filter. (Requires <a href="http://dougal.gunters.org/blog/2004/08/30/text-filter-suite">TFS Core</a>)
 * Author: Ben Millett, Dougal Campbell
 * Author URI: http://ben.momillett.org/
 *
 * History:
 * 1.1 (2008-06-25) - LOLcat day changed to <a href="http://icanhascheezburger.com/2008/06/23/gratests-of-teh-awl-tiem-lolz-nomiashunz/">8 Aug</a>. Not a major update, but version number change to hopefully overcome a wordpress/extend/plugin issue.
 * 0.2 (2007-03-15) - Updated with words from <a href="http://speaklolspeak.com/>LOLspeak</a>.
 * 0.1 (2008-03-11) - Initial release.
 * Use lolcat as the value for post_filter and comment_filter in the custom fields on the write page.
 */

// If you don't want this filter to automatically engage every year
// on 8 Aug, set this to false:
$talk_like_a_lolcat = true;

function lolcat($content) {
	return filter_cdata_content($content,'lolcat_filter');
}

function lolcat_filter($content) {
	$content = $content[1];

	$patterns = array( 
			'/s\b/' => 'z',
			'%\bhas\b%' => 'haz',
			'%\bHas\b%' => 'Haz',
			'%\bhave\b%' => 'haz',
			'%\bHave\b%' => 'Haz',
			'%\bgot\b%' => 'gotz',
			'%\bGot\b%' => 'Gotz',
			'%\band\b%' => 'nd',
			'%\bAnd\b%' => 'Nd',
			'%\bnaked\b%' => 'nekkid',
			'%\bNaked\b%' => 'Nekkid',
			'%\bpirate\b%' => 'pirat',
			'%\bPirate\b%' => 'Pirat',
			'%\bpiratez\b%' => 'pirats',
			'%\bPiratez\b%' => 'Pirats',
			'%\bpiracy\b%' => 'pyracee',
			'%\bPiracy\b%' => 'Pyracee',
			'%\brecall\b%' => 'rekawl',
			'%\bRecall\b%' => 'Rekawl',
			'%\brepublican\b%' => 'republikun',
			'%\bRepublican\b%' => 'Republikun',
			'%\bgreat\b%' => 'grate',
			'%\bGreat\b%' => 'Grate',
			'%\bof\b%' => 'ov',
			'%\bOf\b%' => 'Ov',
			'%\byou\b%' => 'u',
			'%\bYou\b%' => 'U',
			'%\byour\b%' => 'ur',
			'%\bYour\b%' => 'Ur',
			'%\bvia\b%' => 'thx 2',
			'%\bVia\b%' => 'thx 2',
			'%\bthankz\b%' => 'thx',
			'%\bThankz\b%' => 'Thx',
			'%\bthank you\b%' => 'thx',
			'%\bThank [Yy]ou\b%' => 'Thx',
			'%\bfrom\b%' => 'frum',
			'%\bFrom\b%' => 'Frum',
			'%\bthat\b%' => 'dat',
			'%\bThat\b%' => 'Dat',
			'%\bthis\b%' => 'dis',
			'%\bThis\b%' => 'Dis',
			'%\bthose\b%' => 'dose',
			'%\bThose\b%' => 'Dose',
			'%\bthen\b%' => 'den',
			'%\bThen\b%' => 'Den',
			'%\bthem\b%' => 'dem',
			'%\bThem\b%' => 'Dem',
			'%\bthey\b%' => 'dey',
			'%\bThey\b%' => 'Dey',
			'%\bdifficult\b%' => 'diffikult',
			'%\bDifficult\b%' => 'Diffikult',
			'%\bdictionary\b%' => 'dikshunary',
			'%\bdirecting\b%' => 'direktin',
			'%\bdistribute\b%' => 'distwibyut',
			"%\bdon't know\b%" => 'dunno',
			"%\bDon't know\b%" => 'Dunno',
			'%\beducation\b%' => 'edumakayshun',
			'%\bEducation\b%' => 'Edumakayshun',
			'%\bfoot\b%' => 'fut',
			'%\bhorrible\b%' => 'harribl',
			'%\bHorrible\b%' => 'Harribl',
			'%\bhuman\b%' => 'hoomun',
			'%\bHuman\b%' => 'Hoomun',
			'%\binternet\b%' => 'intertubes',
			'%\bInternet\b%' => 'Intertubes',
			'%\bjail\b%' => 'jayl',
			'%\bjewelrey\b%' => 'jewlree',
			'%\bJewelrey\b%' => 'Jewlree',
			'%\bjuice\b%' => 'joos',
			'%\bJuice\b%' => 'Joos',
			'%\bcute\b%' => 'kewt',
			'%\bCute\b%' => 'Kewt',
			'%\bcricket\b%' => 'krikket',
			'%\bCricket\b%' => 'Krikket',
			'%\bChristmas\b%' => 'Krissmus',
			'%\bquestion\b%' => 'kweshun',
			'%\bQuestion\b%' => 'Kweshun',
			'%\bSaturday\b%' => 'Caturday',
			'%\bmaybe\b%' => 'mebbeh',
			'%\bMaybe\b%' => 'Mebbeh',
			'%\bmedicine\b%' => 'medissin',
			'%\bMedicine\b%' => 'Medissin',
			'%\bthe\b%' => 'teh',
			'%\bThe\b%' => 'Teh',
			'%\binvisible\b%' => 'invizbl',
			'%\bInvisible\b%' => 'Invizbl',
			'%\banticipation\b%' => 'antipayshun',
			'%\bawesome\b%' => 'awsum',
			'%\bAwesome\b%' => 'Awsum',
			'%\bcould\b%' => 'cud',
			'%\bCould\b%' => 'Cud',
			'%\bcould have\b%' => 'cudda',
			'%\bwould\b%' => 'wud',
			'%\bWould\b%' => 'Wud',
			'%\bunderwear\b%' => 'unnerware',
			'%\bUnderwear\b%' => 'Unnerware',
			'%\bextreme\b%' => 'xtreem',
			'%\bExtreme\b%' => 'Xtreem',
			'%\bextremely\b%' => 'xtreemly',
			'%\bExtremely\b%' => 'Xtreemly',
			'%\bvanish\b%' => 'vanush',
			'%\bVanish\b%' => 'Vanush',
			'%\bshould\b%' => 'shud',
			'%\bShould\b%' => 'Shud',
			'%\bsquirrel\b%' => 'sqwrl',
			'%\bSquirrel\b%' => 'Sqwrl',
			'%\bsquirrelz\b%' => 'sqwrlz',
			'%\bSquirrelz\b%' => 'Sqwrlz',
			'%\bexplod\b%' => 'splode',
			'%\bexploded\b%' => 'sploded',
			'%\bschool\b%' => 'skool',
			'%\bSchool\b%' => 'Skool',
			'%\bdance\b%' => 'danz',
			'%\bDance\b%' => 'Danz',
			'%\bdog\b%' => 'dawg',
			'%\bDog\b%' => 'Dawg',
			'%\buntil\b%' => 'til',
			'%\bUntil\b%' => 'Til',
			'%\bate\b%' => 'eated',
			'%\bAte\b%' => 'Eated',
			'%\breally\b%' => 'rly',
			'%\bReally\b%' => 'Rly',
			'%\bflavor\b%' => 'flavur',
			'%\bFlavor\b%' => 'Flavur',
			'%\btaste\b%' => 'flavur',
			'%\bTaste\b%' => 'Flavur',
			'%\bhiccups\b%' => 'hikkups',
			'%\bHiccups\b%' => 'Hikkups',
			'%\bbefore\b%' => 'b4',
			'%\bBefore\b%' => 'B4',
			'%\bam\b%' => 'iz',
			'%\bAm\b%' => 'Iz',
			'%\bis\b%' => 'iz',
			'%\bIs\b%' => 'Iz',
			'%\bwas\b%' => 'wuz',
			'%\bWas\b%' => 'Wuz',
			"%\bit'z\b%" => 'iz',
			"%\bIt'z\b%" => 'Iz',
			"%\bit&#8217;z\b%" =>'iz',
			"%\bIt&#8217;z\b%" =>'Iz',
			"%\bI'm\b%" => "I'z",
			"%\bI&#8217;m\b%" => "I&#8217;z",
			'%\bwith\b%' => 'wit',
			'%\bWith\b%' => 'Wit',
			'%\bwithout\b%' => 'witout',
			'%\bWithout\b%' => 'Witout',
			'%\bwill say\b%' => 'sez',
			'%\bsay\b%' => 'sez',
			'%\bSay\b%' => 'Sez',
			'%\bsays\b%' => 'sez',
			'%\bSays\b%' => 'Sez',
			'%\bsaid\b%' => 'sez',
			'%\bSaid\b%' => 'Sez',
			'%\bpicture\b%' => 'piktur',
			'%\bPicture\b%' => 'Piktur',
			'%\bthese\b%' => 'thees',
			'%\bThese\b%' => 'Thees',
			'%\bcat\b%' => 'kitteh',
			'%\bCat\b%' => 'Kitteh',
			'%\bkitten\b%' => 'kitteh',
			'%\bKitten\b%' => 'Kitteh',
			'%\babout\b%' => 'about',
			'%\bAbout\b%' => 'About',
			'%\bactually\b%' => 'akshully',
			'%\bActually\b%' => 'Akshully',
			'%\blove\b%' => 'luv',
			'%\bLove\b%' => 'Luv',
			'%\bloves\b%' => 'luvs',
			'%\bLoves\b%' => 'Luvs',
			'%\bhelp\b%' => 'halp',
			'%\bHelp\b%' => 'Halp',
			'%\boriginal\b%' => 'orijinul',
			'%\bOriginal\b%' => 'Orijinul',
			'%\boriginally\b%' => 'orijinully',
			'%\bOriginally\b%' => 'Orijinully',
			'%\bout of\b%' => 'outta',
			'%\bOut of\b%' => 'Outta',
			'%\bout\b%' => 'owt',
			'%\bOut\b%' => 'Owt',
			
			'%\blike\b%' => 'liek',
			'%\bLike\b%' => 'Liek',
			'%\bknow\b%' => 'noes',
			'%\bKnow\b%' => 'Noes',
			'%\bno\b%' => 'noes',
			'%\bNo\b%' => 'Noes',
			'%\bhave\b%' => 'haz',
			'%\bHave\b%' => 'Haz',
			'%\borphan\b%' => 'orfun',
			'%\bOrphan\b%' => 'Orfun',
			'%\bplease\b%' => 'pleez',
			'%\bPlease\b%' => 'Pleez',
			'%\bhi\b%' => 'oh hai',
			'%\bHi\b%' => 'Oh Hai',
			'%\bhello\b%' => 'oh hai',
			'%\bHello\b%' => 'Oh Hai',
			'%\bgreetings\b%' => 'oh hai',
			'%\bGreetings\b%' => 'Oh Hai',
			'%\bdo\b%' => 'does',
			'%\bDo\b%' => 'Does',
			'%\bwill be\b%' => 'be',
			'%\boccasion\b%' => 'okashun',
			'%\bOccasion\b%' => 'Okashun',
			'%\balways\b%' => 'olwayz',
			'%\bAlways\b%' => 'Olwayz',
			'%\bsome\b%' => 'sum',
			'%\bSome\b%' => 'Sum',
			'%\bsomeday\b%' => 'sumdayz',
			'%\bSomeday\b%' => 'Sumdayz',
			'%\bsure\b%' => 'shur',
			'%\bSure\b%' => 'Shur',
			'%\bmy\b%' => 'mah',
			'%\bMy\b%' => 'Mah',
			'%\bdone\b%' => 'dun',
			'%\bDone\b%' => 'Dun',
			'%\b[Tt]onight\b%' => '2nite',
			'%\bnothing\b%' => 'nuffin',
			'%\bNothing\b%' => 'Nuffin',
			'%\bsorry\b%' => 'sry',
			'%\bSorry\b%' => 'Sry',
			'%\bbucket\b%' => 'bukkit',
			'%\bBucket\b%' => 'Bukkit',
			'%\bfood\b%' => 'fud',
			'%\bFood\b%' => 'Fud',
			'%\byum\b%' => 'nom',
			'%\bYum\b%' => 'Nom',
			'%\bgood\b%' => 'gud',
			'%\bGood\b%' => 'Gud',
			'%\blook\b%' => 'luk',
			'%\bLook\b%' => 'Luk',
			'%\blookz\b%' => 'luks',
			'%\bLookz\b%' => 'Luks',
			'%\bjust\b%' => 'jus',
			'%\bJust\b%' => 'Jus',
			'%\bwhat\b%' => 'wut',
			'%\bWhat\b%' => 'Wut',
			'%\brough\b%' => 'ruff',
			'%\bRough\b%' => 'Ruff',
			'%\bthrough\b%' => 'thru',
			'%\bThrough\b%' => 'Thru',
			'%\bfriend\b%' => 'peep',
			'%\bFriend\b%' => 'Peep',
			'%\bfriendz\b%' => 'peepz',
			'%\bFriendz\b%' => 'Peepz',
			'%\bco[-]?worker\b%' => 'peep',
			'%\bCo[-]?worker\b%' => 'peep',
			'%\bco[-]?workers\b%' => 'peepz',
			'%\bCo[-]?workers\b%' => 'peepz',
			'%\bperson\b%' => 'peep',
			'%\bPerson\b%' => 'Peep',
			'%\bpersonz\b%' => 'peepz',
			'%\bPersonz\b%' => 'Peepz',
			'%\bpeople\b%' => 'peepz',
			'%\bPeople\b%' => 'Peepz',
			'%\bpoison\b%' => 'poyzun',
			'%\bPoison\b%' => 'Poyzun',
			'%\bmore\b%' => 'moar',
			'%\bMore\b%' => 'Moar',
			'/ket\b/' => 'kit',
			'/ketz\b/' => 'kitz',
			'/ing\b/' => 'in',
			'/ingz\b/' => 'inz',
			'/ed\b/' => 'd',
			'/tiol\b/' => 'shul',
			'/tiolz\b/' => 'shulz',
			'/tial\b/' => 'shul',
			'/tialz\b/' => 'shulz',
			'/cial\b/' => 'shul',
			'/cialz\b/' => 'shulz',
			'/tion\b/' => 'shun',
			'/tionz\b/' => 'shunz',
			'/ction\b/' => 'kshun',
			'/ctionz\b/' => 'kshunz',
	
			'/er\b/' => 'r',
			'%\blasr\b%' => 'lazr',
			'%\bhr\b%' => 'her',
		/*	'/ers\b%' => 'rz',
			"/'s\b%" => 'z',
			"/&#8217;s\b%" => 'z',
		*/	
			'%\baz\b%' => 'as',
			'%\bAz\b%' => 'As',
			'%\bhiz\b%' => 'his',
			'%\bHiz\b%' => 'His',
			'/ph/' => 'f',
			// These next two do cool random substitutions
			'/(\.\s)/e' => 'lolavast("$0",3)',
			'/([!\?]\s)/e' => 'lolavast("$0",2)', // Greater chance after exclamation
			);

	// Replace the words:
	$content = array_apply_regexp($patterns,$content);
	
	return $content;
}

// support function for lolcat()
// this could probably be refactored to make it more generic, allowing
// different filters to pass their own patterns in.
function lolavast($ctub = '',$chance2 = 5) {
	$cheezits = array(
				", LOL$ctub",
				"$ctub LOL!!!1!",
				"$ctub Awwww!!!1!",
				"!!!1!",
				);
				
	shuffle($cheezits);
	
	return (((1 == rand(1,$chance2))?array_shift($cheezits):$ctub) . ' ');
}

// Use the lolcat filter on July 7.
if ($talk_like_a_lolcat && '0808' == date('md') && !$_GET['filter']) {
	add_filter('the_content','lolcat');
	add_filter('comment_text','lolcat');
}

?>